"""
something is from https://github.com/pypa/sampleproject
"""

"""A setuptools based setup module.
See:
https://packaging.python.org/guides/distributing-packages-using-setuptools/
https://github.com/pypa/sampleproject
"""

import pathlib

# Always prefer setuptools over distutils
from setuptools import find_packages, setup

here = pathlib.Path(__file__).parent.resolve()

# Get the long description from the README file
long_description = (here / "README.md").read_text(encoding="utf-8")

requires = [
    "beautifulsoup4>=4.11.1",
    "bokeh>=2.4.3",
    "chardet>=5.0.0",
    "cn2an>=0.5.17",
    "holoviews>=1.15.1",
    "imageio>=2.22.2",
    "importlib-metadata>=4.12.0",
    "jieba>=0.42.1",
    "Markdown>=3.4.1",
    "matplotlib>=3.5.3",
    "multiprocess>=0.70.13",
    "numpy>=1.23.3",
    "pandas>=1.4.3",
    "pathtools>=0.1.2",
    "pdfkit>=1.0.0",
    "Pillow>=9.2.0",
    "plotly>=5.10.0",
    "requests>=2.28.1",
    "scikit-learn>=1.1.2",
    "scipy>=1.9.1",
    "seaborn>=0.11.2",
    "selenium>=4.5.0",
    "urllib3>=1.26.12",
]

setup(
    name = "mbapy",
    version = "0.0.1",

    classifiers=[
        "Development Status :: 4 - Beta",
        "Intended Audience :: Science/Research",
        "Topic :: Utilities",
        "License :: OSI Approved :: MIT License",
        "Programming Language :: Python :: 3",
        "Programming Language :: Python :: 3.7",
        "Programming Language :: Python :: 3.8",
        "Programming Language :: Python :: 3.9",
        "Programming Language :: Python :: 3.10",
        "Programming Language :: Python :: 3.11",
        "Programming Language :: Python :: 3 :: Only",
    ],
        
    keywords = ("pip", "mbapy", "Utilities", "scripts"),
    description = "MyBA in Python",
    long_description = long_description,
    long_description_content_type='text/markdown',
    python_requires=">=3.7.0",
    license = "MIT Licence",

    url = "https://github.com/BHM-Bob/BA_PY",
    author = "BHM-Bob G",
    author_email = "bhmfly@foxmail.com",
    
    # package_dir={"": "src"},
    packages=["src/mbapy"],
    
    include_package_data = True,
    platforms = "any",
    
    install_requires=requires,
)
